/* << High C V1.4 >> **********************************************************
**
**	CD tײ؂gp CD PLAYER
**
**	1991.03.19 : CREATE
**	1991.03.23 : FINISH
**
**	< HISTORY >
**	1991.03.19 : CREATE
**	1991.03.25 : PROGRAMt[ĥ܂܂bcꊷɁAIv
**			     ̒lȂ̂C. ĕ\ĂȂ̂C.
**	1991.03.27 : ۸ӰގݸގxpðߑIыȑI̋@\ǉ.
**
**	< note > : TABS = 4
**
**	All Rights Reserved, Copyright (C) Y.Hirata 1991.
**
**	Programmed by Y.Hirata ( Nifty ID : NAB03321 )
**
******************************************************************************/

/*-----------------------------------------------------------------------------
**	CDDA.LIB gp̒ӎ
**
**	1.
**	̧ͯ CDDA.H ݸٰނĉ. CDR.H ͲݸٰނKv܂.
**
**	2.
**	gp֐́ACDDA_switch() ł.
**	PAUSEƂɁAʊ֐gp PAUSE/STOP ꍇɁȀۏ
**	܂.
**
**	3.
**	LINKɂ́ACDDA.LIB ̑ CDR.LIB LINKĉ.
**	܂ALINK߼ -CALLBUFS  2 ȏ̒lw肵ĉ.
**	TWOCASE LINKĉ.
-----------------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <egb.h>
#include <mos.h>
#include <snd.h>
#include <fmc.h>
#include "grp.h"
#include "mostype.h"
#include "elevol.h"
#include "sndplay.h"
#include "key.h"
#include "tape.h"

#define	_CDPN_MAIN
#include "cdpn.h"

/*-----------------------------------------------------------------------------
**	B@\ɑ܂
-----------------------------------------------------------------------------*/
extern char	CDDA_FLG_stop ;					/*  ۸яISTOPH	*/

/*-----------------------------------------------------------------------------
**	ԊĎp  荞݂gp܂.
-----------------------------------------------------------------------------*/
unsigned	Timeno ;						/*  ϊǗԍ					*/

/*-----------------------------------------------------------------------------
**	CTRL+C  Ͻ ̂Ɏgp܂.
-----------------------------------------------------------------------------*/
extern void int24_mask( void ) ;

/*-----------------------------------------------------------------------------
**	۸ыN̵߼݂Ŏgp܂.
-----------------------------------------------------------------------------*/
char	Startplay = FALSE ;					/*  ۸ъJnPLAYH	*/

/*-----------------------------------------------------------------------------
**	~/NOT READY̖Ɏgp܂.
-----------------------------------------------------------------------------*/
char	Noaflg = FALSE ;					/*  ~ɱH		*/

/******************************  TIMER Handler  ******************************/
static int timer_func( void )
/*=============================================================================
**	 荞 
**
**	< INPUT  > : Ȃ
**	< OUTPUT > : Ȃ
**	< RETURN > : 0
=============================================================================*/
{
	Tcount1 ++ ;
	Tcount2 ++ ;
	Tcount3 ++ ;
	return( 0 ) ;
}

/******************************  گď  ********************************/
void palinit( void )
/*=============================================================================
**	16 F گ ̏s.
**
**	< INPUT  > : Ȃ
**	< OUTPUT > : Ȃ
**	< RETURN > : Ȃ
=============================================================================*/
{
	char	para[132] ;
	int		c ;

	DWORD( para+0 ) = 16 ;							/*  o^	*/
	for ( c=0; c<16; c++ ) {
		DWORD( para+ 4+c*8 ) = c ;					/*  NUMBER	*/
		BYTE(  para+ 8+c*8 ) = Palette[c][0] ;		/*  BLUE	*/
		BYTE(  para+ 9+c*8 ) = Palette[c][1] ;		/*  RED		*/
		BYTE(  para+10+c*8 ) = Palette[c][2] ;		/*  GREEN	*/
		BYTE(  para+11+c*8 ) = 0 ;					/*  NULL	*/
	}
	EGB_palette( Gwork,0,para ) ;
}

/****************************  ϊ荞ݏ  ****************************/
void timer_init( void )
/*=============================================================================
**	 荞݂̓o^s.
**
**	< INPUT  > : Ȃ
**	< OUTPUT > : Ȃ
**	< RETURN > : Ȃ
=============================================================================*/
{
	TIM_TIME timer ;

	Tcount1 = 0 ;									/*  CDC ėp			*/
	Tcount2 = 0 ;									/*  ԕ\p		*/
	Tcount3 = 0 ;									/*  p	*/

	timer.mode = 0 ;								/*  Ӱ		*/
	timer.inf  = 0 ;								/*  荞Ӱ	*/
	BSETCODEADR( (char *)&timer.adr,timer_func ) ;
	timer.hcycle = 0x00 ;
	timer.lcycle = 2 ;								/*  20ms			*/
	TIM_settime( &timer,(int *)&Timeno ) ;
}

/******************************  ϊ荞ݏI  ****************************/
void timer_end( void )
/*=============================================================================
**	 荞݂̉s.
**
**	< INPUT  > : Ȃ
**	< OUTPUT > : Ȃ
**	< RETURN > : Ȃ
=============================================================================*/
{
	TIM_clrtime( Timeno ) ;
}

/********************************    *******************************/
void valinit( void )
/*=============================================================================
**	۰ٕϐ̏s.
**
**	< INPUT  > : Ȃ
**	< OUTPUT > : Ȃ
**	< RETURN > : Ȃ
=============================================================================*/
{
	int		c ;

	Flg.pause   = FALSE ;
	Flg.repeat  = FALSE ;
	Flg.shuffle = FALSE ;
	Flg.playon  = FALSE ;
	Flg.program = FALSE ;
	Flg.prgchk  = FALSE ;
	Flg.tape    = FALSE ;
	for ( c=0; c<CDDA_MAX_TRACK; c++ ) {
		Prginf[c] = ZERO ;
		Prgcnt[c] = ZERO ;
	}
	XORno       = ZERO ;
	Musicno     = ZERO ;
	Status      = CDDA_STAT_NOTREADY ;
	Dispno = Dispmin = Dispsec = ZERO ;
}

/*****************************  ϳ̈ʒuݒ  *******************************/
void mossetpos( int evno )
/*=============================================================================
**	ϳ w肳ꂽ  ̒S  .
**
**	< INPUT  > : Ĕԍ(SWVAL+ԍ) or Ȕԍ
**	< OUTPUT > : Ȃ
**	< RETURN > : Ȃ
=============================================================================*/
{
	int		x, y ;
	int		sw ;

/*-----------------------------------------------------------------------------
**	evno  SWVAL傫Ȏɂ́At̏ł.
-----------------------------------------------------------------------------*/
	if ( evno >= SWVAL ) {
		sw = evno - SWVAL ;
		if ( sw < ZERO || sw >= SWPOINT ) return ;
		x = ( Position[sw].e.x - Position[sw].s.x + 1 ) / 2 +
				Position[sw].s.x ;
		y = ( Position[sw].e.y - Position[sw].s.y + 1 ) / 2 +
				Position[sw].s.y ;
		MOS_setpos( x,y ) ;

/*-----------------------------------------------------------------------------
**	Ȕԍw莞̏
-----------------------------------------------------------------------------*/
	} else {
		if ( ( CDDA_INFO_buf.start <= evno && evno <= CDDA_INFO_buf.end &&
				!CDDA_data_check( evno ) ) || evno == SW_TOTAL ) {
			x = PSInf.x + ((evno-1)/20)*121 + 1 + 60 ;
			y = (PSInf.y+YCDOT+1) + ((evno-1)%20)*(YCDOT+1) + 1 + 7 ;
			MOS_setpos( x,y ) ;
		}
	}
}

/********************************    *******************************/
void init( void )
/*=============================================================================
**	EGB / SND / MOS / dqح ̏ݒs.
**
**	< INPUT  > : Ȃ
**	< OUTPUT > : Ȃ
**	< RETURN > : Ȃ
=============================================================================*/
{
	int		c ;

/*	TAPEȈݒ	*/
	TAPE_init() ;

/*  EGB ݒ	*/
	EGB_init( Gwork,GworkSize ) ;				/*  EGB				*/
	EGB_resolution( Gwork,0,3 ) ;				/*  EGB 16 color			*/
	EGB_resolution( Gwork,1,3 ) ;				/*  EGB 16 color			*/
	EGB_displayPage( Gwork,1,3 ) ;				/*  show page 0 & 1 : pr 1	*/
	EGB_writePage( Gwork,1 ) ;

/*	ޏ		*/
	SND_init( Swork ) ;

/*	ϳ ݒ	*/
	MOS_start( Mwork,MworkSize ) ;
	MOS_writePage( 1 ) ;
	MOS_color( 0,C_GREENON ) ;
	mostype( MOSTYPE_STANDARD ) ;
	mossetpos( SW_PLAY+SWVAL ) ;
	dispmouse( FALSE ) ;

/*-----------------------------------------------------------------------------
**	dqحт̐ݒ́A炩߱عݑōsKv܂I
-----------------------------------------------------------------------------*/
	SND_pcm_mode_set( 8 ) ;						/*  PCMӰِݒ	*/

	SND_elevol_init() ;							/*  dqحя		*/
	ELEVOL_set( ELEVOL_MIC,ZERO,ZERO ) ;		/*  MIC  Э				*/
	ELEVOL_set( ELEVOL_CD,ELEVOL_MAX+1,ELEVOL_MAX+1 ) ;		/*  CD  MAX	*/
	Flg.mute = FALSE ;							/*  ЭĂ͉			*/

/*	گ 	*/
	palinit() ;

/*	۰ٕϐ̏lݒ	*/
	for ( c=0; c<SWPOINT; c++ ) Swstat[c] = TRUE ;
	for ( c=0; c<CDDA_MAX_TRACK; c++ ) Infstat[c] = FALSE ;
	Timemode = TM_TR_CLOCK ;
	Playmode = SW_CONTINUE ;
	valinit() ;
	Evol     = ELEVOL_MAX ;
}

/*****************************  ϳ҂  *******************************/
void mosloop( int sw,int *mbot,int *mx,int *my )
/*=============================================================================
**	ϳ  ݸد w肳ꂽԂɂȂ܂ő҂.
**
**	< INPUT  > : sw ݸد.
**	< OUTPUT > : mbot - ݸد
**			   : mx   - ϳW
**			   : my   - ϳW
**	< RETURN > : Ȃ
=============================================================================*/
{
	do {
		MOS_rdpos( mbot,mx,my ) ;
	} while ( *mbot == sw ) ;
}

/**************************  TOTALgϳد  *************************/
int tapeselecton( void )
/*=============================================================================
**	ϳvԘgŸدꂽs.
**
**	< INPUT  > : Ȃ
**	< OUTPUT > : Ȃ
**	< RETURN > : LȂ΁A^l, Ȃ΁AUl.
=============================================================================*/
{
	if ( Playmode != SW_PROGRAM )
		return( FALSE ) ;						/*  ۸щtӰނłȂ	*/
	if ( Flg.tape )
		return( FALSE ) ;						/*  ðߑI			*/
	if ( CDDA_NOW_status != CDDA_STAT_STOP )
		return( FALSE ) ;						/*  ~łȂ			*/
	if ( CDDA_TOTAL_program > ZERO )
		return( FALSE ) ;						/*  ۸ѓo^Ȃ	*/

	dispselectmusicno( SW_TOTAL ) ;
	return( TRUE ) ;
}

/*****************************  ϳĂ  ******************************/
int mosevent( int *no )
/*=============================================================================
**	ϳدꂽɑΉĂ.
**
**	< INPUT  > : Ȃ
**	< OUTPUT > : Ĕԍ(SWVAL+ԍ) or Ȕԍ
**	< RETURN > : ĂȂ ^l, ĂȂȂ Ul.
**
**	ĂɑΉ齲\ONɂ̂ŁAKvɉČĂёŕ\OFFɂ
**	Kv܂.
=============================================================================*/
{
	int		mbot, mx, my ;
	int		c ;

	MOS_rdpos( &mbot,&mx,&my ) ;
	Mosbot = mbot ;
	Mosx   = mx ;
	Mosy   = my ;

/*-----------------------------------------------------------------------------
**	ԕ\ر( ~/NOT READY )
**
**	۸ѐݒȊmF(莞ԕۗ)͕\ر.
**	莞Ԍoߌ̏ꍇɂ́Adisptime()ɂ ۸ъmFp߲ر.
-----------------------------------------------------------------------------*/
	if ( Flg.prgchk || Tcount2 >= PRG_WAIT ) {
		if ( CDDA_NOW_status != CDDA_STAT_PLAY &&
				CDDA_NOW_status != CDDA_STAT_PAUSE &&
				Dispno != -1 ) {
			disptime( ZERO,TM_NODISP ) ;
		}
	}
/*-----------------------------------------------------------------------------
**	Ȕԍ : w肳ꂽȔԍLǂALȂΔ]\.
**
**	̏ꍇł ۸ѐݒȊmF(莞ԕۗ)ɂ́A]\ ر
**	Ȃ.
-----------------------------------------------------------------------------*/
	if ( PSInf.x < mx && mx < (PSInf.x+604) &&
			(PSInf.y+YCDOT+1) < my && my < (PSInf.y+YCDOT+339) ) {
		c = (mx+103) / 121 - 1 ;
		*no = (my-PSInf.y) / 17 + 20*c ;
		if ( CDDA_INFO_buf.start <= *no && *no <= CDDA_INFO_buf.end &&
				!CDDA_data_check( *no ) ) {
			dispselectmusicno( *no ) ;
		} else if ( *no == SW_TOTAL ) {
			tapeselecton() ;
		} else {
			if ( Flg.prgchk || Tcount2 >= PRG_WAIT || XORno != Dispno )
				dispselectmusicno( ZERO ) ;
		}
	} else {
		if ( Flg.prgchk || Tcount2 >= PRG_WAIT || XORno != Dispno )
			dispselectmusicno( ZERO ) ;
	}

	if ( mbot == MOS_LEFT ) {
/*-----------------------------------------------------------------------------
**	Ȕԍ : w肳ꂽȔԍLǂ.
-----------------------------------------------------------------------------*/
		if ( PSInf.x < mx && mx < (PSInf.x+604) &&
				(PSInf.y+YCDOT+1) < my && my < (PSInf.y+YCDOT+339) ) {
			c = (mx+103) / 121 - 1 ;
			*no = (my-PSInf.y) / 17 + 20*c ;
			if ( ( CDDA_INFO_buf.start > *no || *no > CDDA_INFO_buf.end ) &&
				*no != SW_TOTAL ) return( FALSE ) ;
			if ( *no == SW_TOTAL ) {			/*   TAPEI 			*/
				dispmouse( FALSE ) ;
				if ( tapeselecton() ) {				/*  L	*/
					mosloop( mbot,&mbot,&mx,&my ) ;	/*  ϳ̊J҂		*/
					TAPE_autoselect() ;
				}
				dispmouse( TRUE ) ;
				return( FALSE ) ;
			} else {							/*   ȔԍI 		*/
				if ( CDDA_data_check( *no ) )		/*  ް				*/
					return( FALSE ) ;
				dispmouse( FALSE ) ;
				dispevent( *no,TRUE ) ;
				mosloop( mbot,&mbot,&mx,&my ) ;		/*  ϳ̊J҂		*/
				dispmouse( TRUE ) ;
				return( TRUE ) ;
			}
		}
/*-----------------------------------------------------------------------------
**	e : Iꂽ_ŁAON \  .
**	ĂёŁAOFF \Kvȏ邱.
-----------------------------------------------------------------------------*/
		for ( c=0; c<SWPOINT; c++ ) {			/*  					*/
			if ( Position[c].s.x < mx && mx < Position[c].e.x &&
					Position[c].s.y < my && my < Position[c].e.y ) {
				*no = SWVAL + c ;
				dispmouse( FALSE ) ;
				dispevent( *no,TRUE ) ;
				dispmouse( TRUE ) ;
				return( TRUE ) ;
			}
		}
	}
	return( FALSE ) ;
}

/****************************  tȂ̕\  *****************************/
void checkmusic( int no )
/*=============================================================================
**	tȂw肳ꂽɕ\s.
**
**	< INPUT  > : t
**	< OUTPUT > : Ȃ
**	< RETURN > : Ȃ
**
**	ϳ͌ĂёOFFɂĂĉ.
=============================================================================*/
{
	int		c ;

	if ( no < 1 || no > CDDA_MAX_TRACK ) return ;

	switch ( Playmode ) {
	case SW_PROGRAM :
/*-----------------------------------------------------------------------------
**	۸ӰނňȂw肳ĂȂɂ́AUS̋Ȃ(tI
**	)w肳ꂽȂ𖢉t\ɂ.
-----------------------------------------------------------------------------*/
		if ( !CDDA_TOTAL_program ) {
			/*  ۸ӰގɈȂw肳ĂȂ	*/
			disptocmode( SW_PROGRAM,DUMMY ) ;
		}
		Prginf[no-1] ++ ;
		Prgcnt[no-1] ++ ;
		dispmusicno( no,TRUE ) ;
		break ;
	case SW_SINGLE :
/*-----------------------------------------------------------------------------
**	ݸӰނł́Aw肳ꂽȔԍȊÓAOFF\Ƃ.
-----------------------------------------------------------------------------*/
		for ( c=1; c<no; c++ ) dispmusicno( c,FALSE ) ;
		dispmusicno( no,TRUE ) ;
		for ( c=no+1; c<=CDDA_INFO_buf.end; c++ ) dispmusicno( c,FALSE ) ;
		break ;
	case SW_CONTINUE :
/*-----------------------------------------------------------------------------
**	CONTINUEӰނł́AىtȂΑS ON\ ƂAłȂ΁A
**	w肳ꂽȔԍŐȂ OFF\, ȍ~ ON\Ƃ.
-----------------------------------------------------------------------------*/
		if ( Flg.shuffle ) {
			disptoc( FALSE ) ;
		} else {
			for ( c=1; c<no; c++ ) dispmusicno( c,FALSE ) ;
			for ( c=no; c<=CDDA_INFO_buf.end; c++ ) dispmusicno( c,TRUE ) ;
		}
	}
}

/*******************************    ******************************/
void checkswitch( void )
/*=============================================================================
**	tԂɍ킹   ON/OFF \s.
**
**	< INPUT  > : Ȃ
**	< OUTPUT > : Ȃ
**	< RETURN > : Ȃ
=============================================================================*/
{
	if ( Status == CDDA_NOW_status ) return ;

	dispmouse( FALSE ) ;
	switch ( CDDA_NOW_status ) {
	case CDDA_STAT_PLAY :
		if ( Flg.shuffle ) dispshuffle( TRUE ) ;
		else			   dispshuffle( FALSE ) ;
		dispplay( TRUE ) ;
		disppause( FALSE ) ;
		break ;
	case CDDA_STAT_PAUSE :
		if ( Flg.shuffle ) dispshuffle( TRUE ) ;
		else			   dispshuffle( FALSE ) ;
		dispplay( TRUE ) ;
		disppause( TRUE ) ;
		break ;
	case CDDA_STAT_STOP :
		dispshuffle( FALSE ) ;
		dispplay( FALSE ) ;
		disppause( FALSE ) ;
		break ;
	case CDDA_STAT_NOTREADY :
		dispswitch_check( SW_STOP ) ;
		dispmsgclear() ;
	}
	dispmouse( TRUE ) ;
}

/*****************************  PLAY/PAUSE  **************************/
void checkdisp_playmusic( void )
/*=============================================================================
**	t̋ȏ񂨂юԕ\s.
**
**	< INPUT  > : Ȃ
**	< OUTPUT > : Ȃ
**	< RETURN > : Ȃ
=============================================================================*/
{
/*-----------------------------------------------------------------------------
**	tȔԍςĂȂ΁Aԕ\s.
-----------------------------------------------------------------------------*/
	if ( Musicno == CDDA_NOW_musicno ) {
		disptime( CDDA_NOW_musicno,Timemode ) ;
		return ;
	}

/*-----------------------------------------------------------------------------
**	tȔԍςA\  s.
-----------------------------------------------------------------------------*/
/*							 DEBUG 							*/
	if ( CDDA_DEBUG ) {
		printf( "<checkdisp_playmusic> " ) ;
		printf( "musicno : %d -> %d",Musicno,CDDA_NOW_musicno ) ;
		printf( " , mode : %xh , playon : %d\n",Playmode,Flg.playon ) ;
	}
/*							 DEBUG 							*/

	if ( Playmode == SW_PROGRAM ) {
/*-----------------------------------------------------------------------------
**	PȉtɁAtIOɎ̋Ȃ̓tĂ܂Ƃ
**	ŁA\ۂɂ́AKv.
-----------------------------------------------------------------------------*/
		if ( CDDA_NOW_start == CDDA_NOW_end ) {	/*  ȉt			*/
			if ( CDDA_NOW_start != CDDA_NOW_musicno ) return ;	
		}
/*-----------------------------------------------------------------------------
**	tȂςȂ΁AtIȂ۸їpt ޸ .
**	̌ʁAt 0 ɂȂȂ΁AOFF\.
**	tJnɂ́AFlg.playon  ^lł.
-----------------------------------------------------------------------------*/
		if ( Musicno > ZERO && !Flg.playon )
			Prginf[Musicno-1] -- ;
		if ( Prginf[Musicno-1] <= ZERO ) {
			dispmouse( FALSE ) ;
			dispmusicno( Musicno,FALSE ) ;
			dispmouse( TRUE ) ;
		}
	} else {
		switch ( Playmode ) {
		case SW_SINGLE :
/*-----------------------------------------------------------------------------
**	PȉtɁAtIOɎ̋Ȃ̓tĂ܂Ƃ
**	ŁA\ۂɂ́AKv.
-----------------------------------------------------------------------------*/
			if ( CDDA_NOW_start == CDDA_NOW_end ) {	/*  ȉt		*/
				if ( CDDA_NOW_start != CDDA_NOW_musicno ) return ;	
			}
		case SW_CONTINUE :
			if ( Flg.shuffle ) break ;
			if ( Flg.playon ) break ;
			dispmouse( FALSE ) ;
			dispmusicno( Musicno,FALSE ) ;
			dispmusicno( CDDA_NOW_musicno,TRUE ) ;
			dispmouse( TRUE ) ;
			break ;
		}
/*-----------------------------------------------------------------------------
**	tJnɂ́AFlg.playon  ^lł.
-----------------------------------------------------------------------------*/
		if ( !Flg.playon && Musicno > ZERO ) {
			dispmouse( FALSE ) ;
			dispmusicno( Musicno,FALSE ) ;
			dispmusicno( CDDA_NOW_musicno,TRUE ) ;
			dispmouse( TRUE ) ;
		}
	}
	Flg.playon = FALSE ;

/*-----------------------------------------------------------------------------
**	t̋Ȕԍێ.
-----------------------------------------------------------------------------*/
	Musicno = CDDA_NOW_musicno ;

/*-----------------------------------------------------------------------------
**	tԂ̕\s.
-----------------------------------------------------------------------------*/
	disptime( CDDA_NOW_musicno,Timemode ) ;
}

/********************************  STOP  *****************************/
void checkdisp_stopmusic( void )
/*=============================================================================
**	~̋ȏ񂨂юԕ\s.
**
**	< INPUT  > : Ȃ
**	< OUTPUT > : Ȃ
**	< RETURN > : Ȃ
=============================================================================*/
{
	int		c ;

/*-----------------------------------------------------------------------------
**	tԂωԂ̕\  s.
-----------------------------------------------------------------------------*/
	if ( Status == CDDA_NOW_status ) {
		if ( !Noaflg && Tcount3 > NOA_WAIT ) {
			SNDPLAY_stop( STOP_CH ) ;
			SNDPLAY_play( STOP_CH,STOP_SND ) ;
			Tcount3 = ZERO ;
		}
		return ;
	}

	Noaflg  = FALSE ;
	Tcount3 = ZERO ;

/*							 DEBUG 							*/
	if ( CDDA_DEBUG ) {
		printf( "<checkdisp_stopmusic> " ) ;
		printf( "stop - status : %xh -> %xh\n",Status,CDDA_NOW_status ) ;
	}
/*							 DEBUG 							*/

/*-----------------------------------------------------------------------------
**	ԕ\.
-----------------------------------------------------------------------------*/
	disptime( ZERO,TM_NODISP ) ;

/*-----------------------------------------------------------------------------
**	۸Ӱނ̎́A۸ыȂ\ĂԂɉt~
**	Ƃ肦. ̂ߒ~ԂɂȂƂĖɕ\
**	ύXłȂ.
-----------------------------------------------------------------------------*/
	if ( Playmode != SW_PROGRAM || Flg.program ) {
/*-----------------------------------------------------------------------------
**	۸ӰވȊO۸щtIɂ́A\ر.
-----------------------------------------------------------------------------*/
		for ( c=0; c<CDDA_MAX_TRACK; c++ ) {
			Prginf[c] = ZERO ;
			if ( !Flg.repeat ) Prgcnt[c] = ZERO ;
		}
		if ( !Flg.repeat ) {
			if ( Flg.tape ) {					/*  ðߑI			*/
				dispmsgclear() ;
			}
			Flg.tape = FALSE ;
		}
		dispmouse( FALSE ) ;
		if ( Playmode == SW_PROGRAM ) {
			disptocmode( SW_PROGRAM,DUMMY ) ;
		} else {
			disptoc( FALSE ) ;
		}
		if ( Playmode == SW_PROGRAM ) dispprogramtime() ;
		dispmouse( TRUE ) ;
	}
	Flg.program = FALSE ;
	Musicno = ZERO ;
}

/********************************  eject  ****************************/
void checkdisp_eject( void )
/*=============================================================================
**	CD  ꂽԂ̕\s.
**
**	< INPUT  > : Ȃ
**	< OUTPUT > : Ȃ
**	< RETURN > : Ȃ
=============================================================================*/
{
	valinit() ;
	dispmouse( FALSE ) ;
	dispswitch_check( SW_STOP ) ;
	disptocclear() ;
	disptime( ZERO,TM_NODISP ) ;
	dispmsgclear() ;
	MOS_horizon( Position[SW_EXIT].s.x,Position[SW_EXIT].e.x ) ;
	MOS_vertical( Position[SW_EXIT].s.y,Position[SW_EXIT].e.y ) ;
	mossetpos( SW_EXIT+SWVAL ) ;
	dispmouse( TRUE ) ;
	Noaflg  = FALSE ;
	Tcount3 = ZERO ;
}

/********************************  reset  ****************************/
void checkdisp_reset( void )
/*=============================================================================
**	CD   ꂽԂ̕\s.
**
**	< INPUT  > : Ȃ
**	< OUTPUT > : Ȃ
**	< RETURN > : Ȃ
=============================================================================*/
{
	Noaflg  = FALSE ;
	Tcount3 = ZERO ;
	dispmouse( FALSE ) ;
	/*	 PLAY SWITCH ON 	*/
	if ( Startplay ) {
		disperrormsg( CDDA_switch( CDDA_SW_PLAY ) ) ;
		if ( CDDA_NOW_status == CDDA_STAT_PLAY ) dispplay( TRUE ) ;
	} else {
		disperrormsg( CDDA_switch( CDDA_SW_TOCREAD ) ) ;
	}
	disptocmode( Playmode,CDDA_NOW_musicno ) ;
	if ( Playmode == SW_PROGRAM ) dispprogramtime() ;
	MOS_horizon( 0,639 ) ;
	MOS_vertical( 0,479 ) ;
	mossetpos( SW_PLAY+SWVAL ) ;
	dispmouse( TRUE ) ;
}

/*******************************  CDt  ****************************/
void checkstatus( void )
/*=============================================================================
**	tԂɉʕ\s.
**
**	< INPUT  > : Ȃ
**	< OUTPUT > : Ȃ
**	< RETURN > : Ȃ
=============================================================================*/
{
	static char	ready = FALSE ;
	int		ret ;
	int		c ;

	/*	 ð擾 	*/
	ret = CDDA_switch( CDDA_SW_STATUS ) ;
	checkswitch() ;

	if ( ret == CDDA_ERR_REPEAT ) {
/*-----------------------------------------------------------------------------
**	߰ĉtɓ̏
-----------------------------------------------------------------------------*/
		dispmouse( FALSE ) ;
/*-----------------------------------------------------------------------------
**	tJnƓł̂ŁA׸   .
-----------------------------------------------------------------------------*/
		Flg.playon  = TRUE ;
		Flg.program = TRUE ;
		switch ( Playmode ) {
		case SW_SINGLE :
			disptocmode( Playmode,CDDA_NOW_musicno ) ;
			break ;
		case SW_CONTINUE :
			disptocmode( Playmode,DUMMY ) ;
			break ;
		case SW_PROGRAM :
			for ( c=0; c<CDDA_MAX_TRACK; c++ ) {
				Prginf[c] = Prgcnt[c] ;
			}
			disptocmode( SW_PROGRAM,DUMMY ) ;
		}
		dispmouse( TRUE ) ;

	} else if ( ret ) {

/*							 DEBUG 							*/
		if ( CDDA_DEBUG ) {
			if ( ret == CDDA_ERR_NOTREADY ) {
				printf("*") ;
			} else {
				printf( "<checkstatus> " ) ;
				printf( "SW_STATUS error return : %xh",ret ) ;
				printf( " , status : %xh -> %xh\n",Status,CDDA_NOW_status ) ;
			}
		}
/*							 DEBUG 							*/

/*-----------------------------------------------------------------------------
**	NOT READY ԂɂȂꍇ̏
-----------------------------------------------------------------------------*/
		if ( ready ) {
			ready  = FALSE ;
/*							 DEBUG 							*/
			if ( CDDA_DEBUG ) {
				printf( "<checkstatus> " ) ;
				printf( "now CD eject - return : %xh",ret ) ;
				printf( " , status : %xh -> %xh\n",Status,CDDA_NOW_status ) ;
			}
/*							 DEBUG 							*/
			SNDPLAY_stop( STOP_CH ) ;
			SNDPLAY_stop( RESET_CH ) ;
			SNDPLAY_play( EJECT_CH,EJECT_SND ) ;
			checkdisp_eject() ;
		} else {
			if ( !Noaflg && Tcount3 > NOA_WAIT ) {
				SNDPLAY_stop( STOP_CH ) ;
				SNDPLAY_play( STOP_CH,STOP_SND ) ;
				Tcount3 = ZERO ;
			}
		}
		Musicno = ZERO ;

	} else {
		ready = TRUE ;
		if ( CDDA_NOW_status != CDDA_STAT_NOTREADY ) {
			if ( Status == CDDA_STAT_NOTREADY ) {
/*-----------------------------------------------------------------------------
**	NOT READY ԂACD   ꂽ̏
-----------------------------------------------------------------------------*/
/*							 DEBUG 							*/
				if ( CDDA_DEBUG ) {
					printf( "<checkdisp_reset> " ) ;
					printf( "now CD set - return : %xh",ret ) ;
					printf( " , status : %xh -> %xh\n",
							Status,CDDA_NOW_status ) ;
				}
/*							 DEBUG 							*/
				SNDPLAY_stop( STOP_CH ) ;
				SNDPLAY_stop( EJECT_CH ) ;
				SNDPLAY_play( RESET_CH,RESET_SND ) ;
				checkdisp_reset() ;
			} else {
/*-----------------------------------------------------------------------------
**	ʏԂ̏
-----------------------------------------------------------------------------*/
				if ( Status != CDDA_NOW_status ) {

/*							 DEBUG 							*/
					if ( CDDA_DEBUG ) {
						printf( "<checkstatus> " ) ;
						printf( "status : %xh -> %xh\n",
								Status,CDDA_NOW_status ) ;
					}
/*							 DEBUG 							*/

					checkswitch() ;
				}

				switch ( CDDA_NOW_status ) {
				case CDDA_STAT_PLAY :
					Flg.pause = FALSE ;
				case CDDA_STAT_PAUSE :
					SNDPLAY_stop( STOP_CH ) ;
					SNDPLAY_stop( EJECT_CH ) ;
					SNDPLAY_stop( RESET_CH ) ;
					checkdisp_playmusic() ;
					break ;
				case CDDA_STAT_STOP :
					Flg.pause = FALSE ;
					checkdisp_stopmusic() ;
				}
			}	/*  ð擾 CD READY	*/

/*							 DEBUG 							*/
			if ( CDDA_DEBUG ) {
				if ( Status != CDDA_NOW_status ) {
					printf( "<checkstatus> " ) ;
					printf( "normal - status : %xh -> %xh\n",
							Status,CDDA_NOW_status ) ;
				}
			}
/*							 DEBUG 							*/

		}	/*   READY 	*/
	}	/*  ð擾 ERROR or NOERROR	*/

	Status = CDDA_NOW_status ;
}

/*******************************  ȑI  ********************************/
void selectmusic( int no )
/*=============================================================================
**	ȂIꂽ̏s.
**
**	< INPUT  > : Ȕԍ
**	< OUTPUT > : Ȃ
**	< RETURN > : Ȃ
**
**	ϳ͌ĂёOFFɂĂĉ.
=============================================================================*/
{
	int		ret ;

	if ( CDDA_NOW_status == CDDA_STAT_NOTREADY ) {
		return ;
	} else {
		if ( Playmode == SW_PROGRAM ) {
			/*	 Ȕԍ ON 	*/
			ret = CDDA_switch( no ) ;
			if ( !ret ) {
/*-----------------------------------------------------------------------------
**	۸ыȂ̓o^ɂ́Aԕ\́ATM_TR_CLOCK Ƃ.
**	܂ACHECKl۸ыȊmF\ł| ׸޾ .
**	Ȃ̓o^Ƃ́Acheckmusic() ōs.
-----------------------------------------------------------------------------*/
				Timemode   = TM_TR_CLOCK ;
				Flg.prgchk = TRUE ;
				checkmusic( no ) ;
				disptime( no,Timemode ) ;
				TAPE_check() ;
				dispprogramtime() ;
			}
		} else {
			disptime( ZERO,TM_NODISP ) ;
			checkmusic( no ) ;
			/*	 Ȕԍ ON 	*/
			if ( !CDDA_switch( no ) ) {
				dispplay( TRUE ) ;
				Flg.playon = TRUE ;
				if ( Flg.shuffle ) {
					Flg.shuffle = FALSE ;
					dispshuffle( FALSE ) ;
					disptocmode( SW_CONTINUE,no ) ;
				}
			} else {
/*-----------------------------------------------------------------------------
**	w肳ꂽȂtłȂɂ́APLAY݂ OFF\.
-----------------------------------------------------------------------------*/
				switch ( CDDA_NOW_status ) {
				case CDDA_STAT_PLAY :
				case CDDA_STAT_PAUSE :
					break ;
				default :
					dispplay( FALSE ) ;
					dispmusicno( no,FALSE ) ;
				}
			}
			disptime( no,Timemode ) ;
/*-----------------------------------------------------------------------------
**	PAUSEɋȔԍw肳ꂽɂ́Aϳ  PLAY݂ɈړĂ.
-----------------------------------------------------------------------------*/
			if ( CDDA_NOW_status == CDDA_STAT_PAUSE ) {
				mossetpos( SW_PLAY+SWVAL ) ;
			}
		}
	}
}

/******************************  ӰޑI  *******************************/
void selectmode( int mode )
/*=============================================================================
**	tӰނIꂽ̏s.
**
**	< INPUT  > : tӰ
**	< OUTPUT > : Ȃ
**	< RETURN > : Ȃ
**
**	ϳ͌ĂёOFFɂĂĉ.
=============================================================================*/
{
	int		c ;

/*-----------------------------------------------------------------------------
**	etӰނ́AtӰނςs.
-----------------------------------------------------------------------------*/
	switch ( mode ) {
	case SW_PROGRAM :
		Timemode = TM_TR_CLOCK ;
		if ( Playmode != SW_PROGRAM &&
				CDDA_NOW_status != CDDA_STAT_NOTREADY ) {
			MOS_color( 0,C_REDON ) ;
			dispmsgclear() ;
			/*   ىt۸ӰނɈڍs 	*/
			Flg.shuffle = FALSE ;
			dispshuffle( FALSE ) ;
			dispevent( mode+SWVAL,TRUE ) ;
/*-----------------------------------------------------------------------------
**	۸ѓo^󋵂ر.
-----------------------------------------------------------------------------*/
			for ( c=0; c<CDDA_MAX_TRACK; c++ ) {
				Prginf[c] = ZERO ;
				Prgcnt[c] = ZERO ;
			}
			Flg.tape = FALSE ;
			if ( ( CDDA_NOW_status == CDDA_STAT_PLAY ||
					CDDA_NOW_status == CDDA_STAT_PAUSE ) &&
					CDDA_NOW_musicno > ZERO ) {
/*-----------------------------------------------------------------------------
**	t(PAUSE)Ȃ΁A̋Ȃ۸ѓo^.
-----------------------------------------------------------------------------*/
				Flg.program = TRUE ;
				Flg.prgchk  = TRUE ;
				Prginf[CDDA_NOW_musicno-1] ++ ;
				Prgcnt[CDDA_NOW_musicno-1] ++ ;
			}
			disptocmode( SW_PROGRAM,DUMMY ) ;
			Playmode = SW_PROGRAM ;
			disptimeprgsw() ;
		}
		Playmode = SW_PROGRAM ;
		/*	 PROGRAM MODE SWITCH ON 	*/
		CDDA_switch( CDDA_SW_PROGRAM ) ;
/*-----------------------------------------------------------------------------
**	ײ CALL ɁA۸ѓo^Ԃݒ肳.
-----------------------------------------------------------------------------*/
		dispprogramtime() ;
		break ;
	case SW_SINGLE :
		if ( Playmode != SW_SINGLE &&
				CDDA_NOW_status != CDDA_STAT_NOTREADY ) {
			MOS_color( 0,C_YELLOW ) ;
			dispmsgclear() ;
			/*   ىt۸ӰނɈڍs 	*/
			Flg.shuffle = FALSE ;
			dispshuffle( FALSE ) ;
			dispevent( mode+SWVAL,TRUE ) ;
/*-----------------------------------------------------------------------------
**	tȂ΁AtȂON\.
**	~Ȃ΁AׂON\.
-----------------------------------------------------------------------------*/
			if ( CDDA_NOW_status == CDDA_STAT_STOP ) {
				disptoc( FALSE ) ;
			} else {
				disptocmode( SW_SINGLE,CDDA_NOW_musicno ) ;
			}
			if ( Playmode == SW_PROGRAM ) {
				Playmode = SW_SINGLE ;
				disptimeprgsw() ;
			}
		}
		Playmode = SW_SINGLE ;
		/*	 SINGLE MODE SWITCH ON 	*/
		CDDA_switch( CDDA_SW_SINGLE ) ;
		break ;
	case SW_CONTINUE :
		if ( Playmode != SW_CONTINUE &&
				CDDA_NOW_status != CDDA_STAT_NOTREADY ) {
			MOS_color( 0,C_GREENON ) ;
			dispmsgclear() ;
			/*   ىt۸ӰނɈڍs 	*/
			Flg.shuffle = FALSE ;
			dispshuffle( FALSE ) ;
			dispevent( mode+SWVAL,TRUE ) ;
			if ( CDDA_NOW_status == CDDA_STAT_PLAY ||
					CDDA_NOW_status == CDDA_STAT_PAUSE ) {
				disptocmode( SW_CONTINUE,CDDA_NOW_musicno ) ;
			} else {
				disptoc( FALSE ) ;
			}
			if ( Playmode == SW_PROGRAM ) {
				Playmode = SW_CONTINUE ;
				disptimeprgsw() ;
			}
			Flg.playon  = FALSE ;
		}
		Playmode = SW_CONTINUE ;
		/*	 CONTINUE MODE SWITCH ON 	*/
		CDDA_switch( CDDA_SW_CONTINUE ) ;
	}
}

/*****************************  FF/REW I  *****************************/
void selectffrew( int mode )
/*=============================================================================
**	摗/߂肪Iꂽ̏s.
**
**	< INPUT  > : 摗/߂轲
**	< OUTPUT > : Ȃ
**	< RETURN > : Ȃ
**
**	ϳ͌ĂёOFFɂĂĉ.
=============================================================================*/
{
	int		mbot, mx, my ;
	int		no, evno ;

/*-----------------------------------------------------------------------------
**	Flg.prgchk ^lƁAԕ\Ȃ̂ŁAFALSEɂ҂Ԃر.
-----------------------------------------------------------------------------*/
	Flg.prgchk = FALSE ;
	Tcount2 = PRG_WAIT + 1 ;

	evno = mode + SWVAL ;

/*-----------------------------------------------------------------------------
**	tPAUSEłȂ΁AOFFɂ  .
-----------------------------------------------------------------------------*/
	if ( CDDA_NOW_status != CDDA_STAT_PLAY &&
			CDDA_NOW_status != CDDA_STAT_PAUSE ) {
		dispevent( evno,FALSE ) ;
		return ;
	}

/*-----------------------------------------------------------------------------
**	Ȕԍςɂ́Aŋȕ\ON/OFFŝŁAtJn
**	lɁAFlg.playon  TRUE ɂĂ.
**
**	 ĂԂ́AŌJԂs.
**	 ꂽɁA݂.
**
**	摗/߂̽ONƂāAײ  CALL ɂ́A ꂽ
**	_ŁÂƂ ײ ɒʒm. (CDDA_SW_BREAKCALL)
-----------------------------------------------------------------------------*/
	switch ( mode ) {
	case SW_REWMUSIC :
		no = CDDA_NOW_musicno ;
		/*	 Ȗ߂ SWITCH ON 	*/
		CDDA_switch( CDDA_SW_REWMUSIC ) ;
		if ( no != CDDA_NOW_musicno ) {
			Flg.playon = TRUE ;
			dispmusicno( CDDA_NOW_musicno,TRUE ) ;
			if ( Playmode == SW_SINGLE ) {
				dispmusicno( no,FALSE ) ;
			}
		}
		disptime( CDDA_NOW_musicno,Timemode ) ;
		mosloop( MOS_LEFT,&mbot,&mx,&my ) ;
		/*	 SWITCH J 	*/
		CDDA_switch( CDDA_SW_BREAK ) ;
		dispevent( evno,FALSE ) ;
		break ;
	case SW_REWTIME :
		no = CDDA_NOW_musicno ;
		/*	 Ԗ߂ SWITCH ON 	*/
		CDDA_switch( CDDA_SW_REWTIME ) ;
		if ( no != CDDA_NOW_musicno ) {
			Flg.playon = TRUE ;
			dispmusicno( CDDA_NOW_musicno,TRUE ) ;
			if ( Playmode == SW_SINGLE ) {
				dispmusicno( no,FALSE ) ;
			}
		}
		disptime( CDDA_NOW_musicno,Timemode ) ;
		while ( TRUE ) {
			MOS_rdpos( &mbot,&mx,&my ) ;
			if ( mbot != MOS_LEFT ) break ;
			no = CDDA_NOW_musicno ;
			/*	 Ԗ߂ SWITCH ON 	*/
			if ( CDDA_switch( CDDA_SW_REWTIME ) ) break ;
			if ( no != CDDA_NOW_musicno ) {
				Flg.playon = TRUE ;
				dispmusicno( CDDA_NOW_musicno,TRUE ) ;
				if ( Playmode == SW_SINGLE ) {
					dispmusicno( no,FALSE ) ;
				}
			}
			disptime( CDDA_NOW_musicno,Timemode ) ;
		} ;
		mosloop( MOS_LEFT,&mbot,&mx,&my ) ;
		/*	 SWITCH J 	*/
		CDDA_switch( CDDA_SW_BREAK ) ;
		dispevent( evno,FALSE ) ;
		break ;
	case SW_FFTIME :
		no = CDDA_NOW_musicno ;
		/*	 ԑ SWITCH ON 	*/
		CDDA_switch( CDDA_SW_FFTIME ) ;
		if ( no != CDDA_NOW_musicno ) {
			if ( Playmode == SW_PROGRAM ) {
				Flg.playon = TRUE ;
				if ( no > ZERO ) Prginf[no-1] -- ;
				if ( Prginf[no-1] <= ZERO ) dispmusicno( no,FALSE ) ;
			} else {
				dispmusicno( no,FALSE ) ;
			}
			dispmusicno( CDDA_NOW_musicno,TRUE ) ;
		}
		disptime( CDDA_NOW_musicno,Timemode ) ;
		while ( TRUE ) {
			MOS_rdpos( &mbot,&mx,&my ) ;
			if ( mbot != MOS_LEFT ) break ;
			no = CDDA_NOW_musicno ;
			/*	 ԑ SWITCH ON 	*/
			if ( CDDA_switch( CDDA_SW_FFTIME ) ) break ;
			if ( no != CDDA_NOW_musicno ) {
				if ( Playmode == SW_PROGRAM ) {
					Flg.playon = TRUE ;
					if ( no > ZERO ) Prginf[no-1] -- ;
					if ( Prginf[no-1] <= ZERO ) dispmusicno( no,FALSE ) ;
				} else {
					dispmusicno( no,FALSE ) ;
				}
				dispmusicno( CDDA_NOW_musicno,TRUE ) ;
			}
			disptime( CDDA_NOW_musicno,Timemode ) ;
		} ;
		mosloop( MOS_LEFT,&mbot,&mx,&my ) ;
		/*	 SWITCH J 	*/
		CDDA_switch( CDDA_SW_BREAK ) ;
		dispevent( evno,FALSE ) ;
		break ;
	case SW_FFMUSIC :
		no = CDDA_NOW_musicno ;
		/*	 ȑ SWITCH ON 	*/
		CDDA_switch( CDDA_SW_FFMUSIC ) ;
		if ( no != CDDA_NOW_musicno ) {
			if ( Playmode == SW_PROGRAM ) {
				Flg.playon = TRUE ;
				if ( no > ZERO ) Prginf[no-1] -- ;
				if ( Prginf[no-1] <= ZERO ) dispmusicno( no,FALSE ) ;
			} else {
				dispmusicno( no,FALSE ) ;
			}
			dispmusicno( CDDA_NOW_musicno,TRUE ) ;
		}
		disptime( CDDA_NOW_musicno,Timemode ) ;
		mosloop( MOS_LEFT,&mbot,&mx,&my ) ;
		/*	 SWITCH J 	*/
		CDDA_switch( CDDA_SW_BREAK ) ;
		dispevent( evno,FALSE ) ;
	}
}

/*******************************  tI  ******************************/
void selectplay( int mode )
/*=============================================================================
**	tIꂽ̏s.
**
**	< INPUT  > : t
**	< OUTPUT > : Ȃ
**	< RETURN > : Ȃ
**
**	ϳ͌ĂёOFFɂĂĉ.
=============================================================================*/
{
	int		no, evno ;

	evno = mode + SWVAL ;
	switch ( mode ) {
	case SW_SHUFFLE :
		Flg.shuffle = FALSE ;
/*-----------------------------------------------------------------------------
**	َw莞́ACONTINUEӰނƓ\Ƃ
-----------------------------------------------------------------------------*/
		disptoc( FALSE ) ;
		selectmode( SW_CONTINUE ) ;
		if ( CDDA_NOW_status == CDDA_STAT_NOTREADY ) {
			dispevent( evno,FALSE ) ;
			break ;
		}
		/*	 SHUFFLE SWITCH ON 	*/
		no = CDDA_switch( CDDA_SW_SHUFFLE ) ;
		if ( !no ) {
			/*  t OK!	*/
			Flg.playon  = TRUE ;
			Flg.shuffle = TRUE ;
			dispshuffle( TRUE ) ;
			dispplay( TRUE ) ;
			checkmusic( CDDA_NOW_start ) ;
			disptime( CDDA_NOW_start,Timemode ) ;
		} else {
			/*  t NG!	*/
			dispshuffle( FALSE ) ;
			dispplay( FALSE ) ;
			disptoc( FALSE ) ;
			disptime( ZERO,TM_NODISP ) ;
		}
		break ;
	case SW_PLAY :
		if ( CDDA_NOW_status == CDDA_STAT_NOTREADY ) {
			dispevent( evno,FALSE ) ;
			break ;
		}
		if ( Playmode == SW_PROGRAM && !CDDA_TOTAL_program ) {
/*-----------------------------------------------------------------------------
**	۸ӰނȂ̂ɈȂw肳ĂȂɂ́ACONTINUEӰނɈڍsĉt
**	.
-----------------------------------------------------------------------------*/
			selectmode( SW_CONTINUE ) ;
			/*	 PLAY SWITCH ON 	*/
			no = CDDA_switch( CDDA_SW_PLAY ) ;
			if ( no ) dispplay( FALSE ) ;
		} else {
			/*	 PLAY SWITCH ON 	*/
			no = CDDA_switch( CDDA_SW_PLAY ) ;
			disperrormsg( no ) ;
			if ( !no ) {
				/*  t OK!	*/
				if ( !Flg.pause ) Flg.playon  = TRUE ;
				switch ( Playmode ) {
				case SW_PROGRAM :
					Flg.program = TRUE ;
					disptocmode( SW_PROGRAM,DUMMY ) ;
					break ;
				case SW_CONTINUE :
					if ( Flg.shuffle && !Flg.pause ) {
						Flg.shuffle = FALSE ;
						dispshuffle( FALSE ) ;
						disptocmode( SW_CONTINUE,CDDA_NOW_musicno ) ;
					}
					break ;
				case SW_SINGLE :
					checkmusic( CDDA_NOW_start ) ;
				}
			} else {
				/*  t NG!	*/
				if ( CDDA_NOW_status != CDDA_STAT_PLAY ) {
					dispplay( FALSE ) ;
				}
			}
		}
		disptime( CDDA_NOW_start,Timemode ) ;
		Flg.pause = FALSE ;
	}
}

/*******************************  ~I  ******************************/
void selectstop( int mode )
/*=============================================================================
**	~Iꂽ̏s.
**
**	< INPUT  > : ~
**	< OUTPUT > : Ȃ
**	< RETURN > : Ȃ
**
**	ϳ͌ĂёOFFɂĂĉ.
=============================================================================*/
{
	int		evno ;
	int		c ;

	evno = mode + SWVAL ;
	switch ( mode ) {
	case SW_STOP :
		Flg.pause   = FALSE ;
		Flg.shuffle = FALSE ;
		Flg.program = FALSE ;
/*-----------------------------------------------------------------------------
**	۸Ӱގɒ~Ȃ۸ѐݒȂر
-----------------------------------------------------------------------------*/
		if ( Playmode == SW_PROGRAM && CDDA_NOW_status == CDDA_STAT_STOP ) {
			for ( c=0; c<CDDA_MAX_TRACK; c++ ) {
				Prginf[c] = ZERO ;
				Prgcnt[c] = ZERO ;
			}
			Flg.tape = FALSE ;
			disptocmode( SW_PROGRAM,DUMMY ) ;
			disptime( ZERO,TM_NODISP ) ;
			/*	 STOP SWITCH ON 	*/
			CDDA_switch( CDDA_SW_STOP ) ;
			dispmsgclear() ;
			dispprogramtime() ;
		}
		if ( CDDA_NOW_status == CDDA_STAT_PLAY ||
				CDDA_NOW_status == CDDA_STAT_PAUSE ) {
			/*	 STOP SWITCH ON 	*/
			CDDA_switch( CDDA_SW_STOP ) ;
		}
		dispshuffle( FALSE ) ;
		disppause( FALSE ) ;
		dispplay( FALSE ) ;
		dispevent( evno,FALSE ) ;
		break ;
	case SW_PAUSE :
		if ( CDDA_NOW_status == CDDA_STAT_NOTREADY ) {
			dispevent( evno,FALSE ) ;
			break ;
		}
		if ( Playmode == SW_PROGRAM && CDDA_TOTAL_program == ZERO ) {
			dispevent( evno,FALSE ) ;
			break ;
		}
		if ( Flg.pause ) {
			Flg.pause = FALSE ;
		} else {
			Flg.pause = TRUE ;
			dispplay( TRUE ) ;
		}
		disppause( Flg.pause ) ;
		/*	 PAUSE SWITCH ON/OFF 	*/
		CDDA_switch( CDDA_SW_PAUSE ) ;
		break ;
	}
}

/******************************  ۸ё쏈  ****************************/
void selectprogramsw( int sw )
/*=============================================================================
**	۸т̊mF/رIꂽ̏s.
**
**	< INPUT  > : ۸ъmF/ر
**	< OUTPUT > : Ȃ
**	< RETURN > : Ȃ
**
**	ϳ͌ĂёOFFɂĂĉ.
=============================================================================*/
{
	int		no, evno ;
	int		nowmusic ;

	evno = sw + SWVAL ;
	dispevent( evno,FALSE ) ;

	if ( Playmode != SW_PROGRAM || CDDA_NOW_status == CDDA_STAT_NOTREADY ) {
		return ;
	}

	switch ( sw ) {
	case SW_CHECK :
		Timemode = TM_TR_CLOCK ;
		/*	 SCHECK SWITCH ON 	*/
		no = CDDA_switch( CDDA_SW_PRG_CHECK ) ;
		if ( no ) dispmusicno( CDDA_NOW_musicno,TRUE ) ;
		Flg.prgchk = TRUE ;
/*							 DEBUG 							*/
		if ( CDDA_DEBUG ) {
			printf( "<SW_CHECK> " ) ;
			printf( "no = %d , %d Ȗ , musicno = %d\n",
					no,CDDA_COUNT_program,CDDA_NOW_musicno ) ;
		}
/*							 DEBUG 							*/
		dispselectmusicno( CDDA_NOW_musicno ) ;
		disptime( CDDA_NOW_musicno,Timemode ) ;
		TAPE_check() ;
		dispprogramtime() ;
		break ;
	case SW_CLEAR :
		nowmusic = CDDA_NOW_musicno ;
		/*	 CLEAR SWITCH ON 	*/
		no = CDDA_switch( CDDA_SW_PRG_CLEAR ) ;
		if ( no > ZERO ) {
			Timemode = TM_TR_CLOCK ;
			Prginf[no-1] -- ;
			Prgcnt[no-1] -- ;
			if ( Prginf[no-1] <= ZERO ) {
				dispmusicno( no,FALSE ) ;
			}
			Flg.prgchk = TRUE ;
			dispselectmusicno( CDDA_NOW_musicno ) ;
			disptime( CDDA_NOW_musicno,Timemode ) ;
/*-----------------------------------------------------------------------------
**	status擾̋Ȕԍω Prginf  ޸ ̂h߂ɁA
**	ŁAFlg.playon  TRUE ɂĂ. (At̋Ȃ폜)
-----------------------------------------------------------------------------*/
			if ( CDDA_NOW_status == CDDA_STAT_PLAY ||
					CDDA_NOW_status == CDDA_STAT_PAUSE ) {
				if ( no == nowmusic ) Flg.playon = TRUE ;
			}
/*-----------------------------------------------------------------------------
**	t(PAUSE)Ō̋Ȃ폜ꍇɂ́AðߑIر.
-----------------------------------------------------------------------------*/
			if ( !CDDA_TOTAL_program ) {
				Flg.tape = FALSE ;
				dispmsgclear() ;
			}
			TAPE_check() ;
			dispprogramtime() ;
		}
	}
}

/******************************  dqحя  *****************************/
void selectelevol( void )
/*=============================================================================
**	dqحт̑s.
**
**	< INPUT  > : Ȃ
**	< OUTPUT > : Ȃ
**	< RETURN > : Ȃ
**
**	ϳ͌ĂёOFFɂĂĉ.
=============================================================================*/
{
	int		mbot, mx, my ;
	int		vol ;

/*-----------------------------------------------------------------------------
**	MUTE  ON/OFF ́Aϳ߰ĂȂ.
-----------------------------------------------------------------------------*/
	Flg.mute = FALSE ;
	ELEVOL_set( ELEVOL_CD,Evol+1,Evol+1 ) ;					/*  CD		*/
	while ( TRUE ) {
		MOS_rdpos( &mbot,&mx,&my ) ;
		if ( mbot != MOS_LEFT ) break ;
		if ( mx < Position[SW_ELEVOL].s.x ) {				/*  MIN		*/
			Evol = ELEVOL_MIN ;
		} else if ( mx > Position[SW_ELEVOL].e.x ) {		/*  MAX		*/
			Evol = ELEVOL_MAX ;
		} else {											/*  VAL		*/
			vol  = ( mx - Position[SW_ELEVOL].s.x ) / 3 ;
			Evol = ( vol + 2 ) * 4 ;
		}
		dispelevol() ;
		ELEVOL_set( ELEVOL_CD,Evol+1,Evol+1 ) ;				/*  CD		*/
	} ;
	mosloop( MOS_LEFT,&mbot,&mx,&my ) ;
}

/******************************  ď\  ******************************/
void debugevent( int evno )
/*=============================================================================
**	Ă̑IԂWo͂.
**
**	< INPUT  > : Ľ
**	< OUTPUT > : Ȃ
**	< RETURN > : Ȃ
=============================================================================*/
{
	if ( !CDDA_DEBUG ) return ;

	printf( "<event> switch on : " ) ;
	if ( evno >= SWVAL ) {
		switch ( evno-SWVAL ) {
		case SW_EXIT :
			printf( "EXIT\n" ) ;
			break ;
		case SW_TIME :
			printf( "TIME\n" ) ;
			break ;
		case SW_REPEAT :
			printf( "REPEAT\n" ) ;
			break ;
		case SW_CHECK :
			printf( "CHECK\n" ) ;
			break ;
		case SW_CLEAR :
			printf( "CLEAR\n" ) ;
			break ;
		case SW_STOP :
			printf( "STOP\n" ) ;
			break ;
		case SW_PAUSE :
			printf( "PAUSE\n" ) ;
			break ;
		case SW_SHUFFLE :
			printf( "SHUFFLE\n" ) ;
			break ;
		case SW_PLAY :
			printf( "PLAY\n" ) ;
			break ;
		case SW_REWMUSIC :
			printf( "REW MUSIC\n" ) ;
			break ;
		case SW_REWTIME :
			printf( "REW TIME\n" ) ;
			break ;
		case SW_FFTIME :
			printf( "FF TIME\n" ) ;
			break ;
		case SW_FFMUSIC :
			printf( "FF MUSIC\n" ) ;
			break ;
		case SW_PROGRAM :
			printf( "PROGRAM\n" ) ;
			break ;
		case SW_SINGLE :
			printf( "SINGLE\n" ) ;
			break ;
		case SW_CONTINUE :
			printf( "CONTINUE\n" ) ;
			break ;
		case SW_ELEVOL :
			printf( "ELEVOL\n" ) ;
			break ;
		}
	} else {
		printf( "Ȕԍ %d\n",evno ) ;
	}
}

/********************************  ď  ********************************/
int event( void )
/*=============================================================================
**	w肳ꂽs.
**
**	< INPUT  > : Ȃ
**	< OUTPUT > : Ȃ
**	< RETURN > : I̎ ^l, ȊO Ul.
=============================================================================*/
{
	int		evno ;
	int		mbot, mx, my ;

	if ( mosevent( &evno ) ) {

/*							 DEBUG 							*/
		if ( CDDA_DEBUG ) {
			debugevent( evno ) ;
		}
/*							 DEBUG 							*/

/*
**	삠
*/
		if ( CDDA_NOW_status == CDDA_STAT_STOP ||
				CDDA_NOW_status == CDDA_STAT_NOTREADY ) {
			Noaflg = TRUE ;
			SNDPLAY_stop( STOP_CH ) ;
			Tcount3 = NOA_WAIT + 1 ;
		}
		dispmouse( FALSE ) ;
/*-----------------------------------------------------------------------------
**	evno  SWVAL傫Ȏɂ́At̏ł.
-----------------------------------------------------------------------------*/
		if ( evno >= SWVAL ) {
/*-----------------------------------------------------------------------------
**	EXIT / TIME / REPEAT / ELEVOL 
-----------------------------------------------------------------------------*/
			switch ( evno-SWVAL ) {
			case SW_EXIT :
				SNDPLAY_play( EXIT_CH,EXIT_SND ) ;
				/*	 EJECT SWITCH ON 	*/
				CDDA_switch( CDDA_SW_EXIT ) ;
				dispevent( evno,FALSE ) ;
				return( TRUE ) ;
			case SW_TIME :
				if ( CDDA_NOW_status != CDDA_STAT_PLAY &&
						CDDA_NOW_status != CDDA_STAT_PAUSE ) break ;
				switch ( Timemode ) {
				case TM_TR_CLOCK :
					Timemode = TM_TR_TIME ;
					break ;
				case TM_TR_TIME :
					Timemode = TM_DISC_CLOCK ;
					break ;
				case TM_DISC_CLOCK :
					Timemode = TM_DISC_TIME ;
					break ;
				case TM_DISC_TIME :
					Timemode = TM_TR_CLOCK ;
					break ;
				default :
					Timemode = TM_TR_CLOCK ;
				}
/*-----------------------------------------------------------------------------
**	Flg.prgchk ^lƁAԕ\Ȃ̂ŁAFALSEɂ҂Ԃر.
-----------------------------------------------------------------------------*/
				Flg.prgchk = FALSE ;
				Tcount2 = PRG_WAIT + 1 ;
				disptime( CDDA_NOW_musicno,Timemode ) ;
				break ;
			case SW_REPEAT :
				if ( Flg.repeat ) {
					Flg.repeat = FALSE ;
				} else {
					Flg.repeat = TRUE ;
				}
				/*	 REPEAT SWITCH ON/OFF 	*/
				CDDA_switch( CDDA_SW_REPEAT ) ;
				disprepeat( Flg.repeat ) ;
				break ;
			case SW_ELEVOL :
				selectelevol() ;
				break ;
			}
/*-----------------------------------------------------------------------------
**	CHECK/CLEAR / STOP / PAUSE / SHUFFLE / PLAY / FF/REW / MODE 
-----------------------------------------------------------------------------*/
			switch ( evno-SWVAL ) {
			case SW_CHECK :
			case SW_CLEAR :
				selectprogramsw( evno-SWVAL ) ;
				break ;
			case SW_STOP :
			case SW_PAUSE :
				selectstop( evno-SWVAL ) ;
				break ;
			case SW_SHUFFLE :
			case SW_PLAY :
				selectplay( evno-SWVAL ) ;
				break ;
			case SW_REWMUSIC :
			case SW_REWTIME :
			case SW_FFTIME :
			case SW_FFMUSIC :
				selectffrew( evno-SWVAL ) ;
				break ;
			case SW_PROGRAM :
			case SW_SINGLE :
			case SW_CONTINUE :
				selectmode( evno-SWVAL ) ;
			}
/*-----------------------------------------------------------------------------
**	Ȕԍw莞̏
-----------------------------------------------------------------------------*/
		} else {
			selectmusic( evno ) ;
		}
/*-----------------------------------------------------------------------------
**	̎w肳ꂽI邽߂ ϳ ̊J҂.
**	(  ϳ ɔ )
-----------------------------------------------------------------------------*/
		mosloop( MOS_LEFT,&mbot,&mx,&my ) ;		/*  ϳ̊J҂			*/
		dispmouse( TRUE ) ;
	}
	return( FALSE ) ;
}

/******************************  CDtJn  *****************************/
void start( void )
/*=============================================================================
**	CD PLAYER ̋@\s.
**
**	< INPUT  > : Ȃ
**	< OUTPUT > : Ȃ
**	< RETURN > : Ȃ
=============================================================================*/
{
	int		c ;
	char	*opening = "΂炭҂...." ;
	char	*err = "܂...." ;

/*	ϳ		*/
	dispmouse( FALSE ) ;

/*-----------------------------------------------------------------------------
**	ݸүޕ\
-----------------------------------------------------------------------------*/
	EGB_color( Gwork,0,COLOR_TITLE ) ;
	EGB_color( Gwork,1,COLOR_TITLE_BACK ) ;
	EGB_paintMode( Gwork,0x02 ) ;
	EGB_writeMode( Gwork,PSET ) ;
	EGB_fontStyle( Gwork,0x0005 ) ;				/*  et&				*/
	c = ( 80 - strlen( opening ) ) / 2 * XCDOT ;
	disptext( Gwork,c,239,opening ) ;
	EGB_fontStyle( Gwork,0x0000 ) ;				/*  ʏ핶				*/

/*-----------------------------------------------------------------------------
**	CD 
-----------------------------------------------------------------------------*/
	/*	 w 	*/
	disperrormsg( CDDA_switch( CDDA_SW_INIT ) ) ;
	Status = CDDA_NOW_status ;

/*-----------------------------------------------------------------------------
**	z߰ނݒ肵A`.(`Ăߒʂɕ\Ȃ)
-----------------------------------------------------------------------------*/
	Wpagebuf = malloc( 640*240 ) ;
	if ( Wpagebuf == NULL ) {
		EGB_color( Gwork,0,COLOR_ERROR ) ;
		EGB_color( Gwork,1,COLOR_TITLE_BACK ) ;
		EGB_paintMode( Gwork,0x02 ) ;
		EGB_writeMode( Gwork,PSET ) ;
		EGB_fontStyle( Gwork,0x0005 ) ;			/*  et&				*/
		c = ( 80 - strlen( err ) ) / 2 * XCDOT ;
		disptext( Gwork,c,239,err ) ;
		EGB_fontStyle( Gwork,0x0000 ) ;			/*  ʏ핶				*/
		return ;
	}
	EGB_resolutionRam( Gwork,WPAGE,4,640,480,Wpagebuf ) ;
	EGB_writePage( Gwork,WPAGE ) ;
	EGB_color( Gwork,1,COLOR_SCREEN_BACK ) ;
	EGB_clearScreen( Gwork ) ;

/*-----------------------------------------------------------------------------
**	ʕ\
-----------------------------------------------------------------------------*/
	disptitle() ;
	dispswitch() ;
	disptoc( TRUE ) ;
	if ( Status == CDDA_STAT_PLAY ) {			/*  tꍇ		*/
		dispplay( TRUE ) ;
		for ( c=1; c<CDDA_NOW_musicno; c++ ) dispmusicno( c,FALSE ) ;
	} else {
		/*	 PLAY SWITCH ON 	*/
		if ( Startplay ) disperrormsg( CDDA_switch( CDDA_SW_PLAY ) ) ;
	}
	EGB_writePage( Gwork,1 ) ;
	put( Gwork,0,0,639,479,(unsigned int)Wpagebuf,4 ) ;
	free( Wpagebuf ) ;

/*	ϳ\		*/
	if ( CDDA_NOW_status == CDDA_STAT_NOTREADY ) {
		MOS_horizon( Position[SW_EXIT].s.x,Position[SW_EXIT].e.x ) ;
		MOS_vertical( Position[SW_EXIT].s.y,Position[SW_EXIT].e.y ) ;
		mossetpos( SW_EXIT+SWVAL ) ;
	} else {
		MOS_horizon( 0,639 ) ;
		MOS_vertical( 0,479 ) ;
		mossetpos( SW_PLAY+SWVAL ) ;
	}
	dispmouse( TRUE ) ;

/*-----------------------------------------------------------------------------
**	COMPACT DISC PLAYER
-----------------------------------------------------------------------------*/
	timer_init() ;								/*  ϊ荞ݓo^			*/
	Tcount1 = CDC_WAIT + 1 ;
	Tcount2 = PRG_WAIT + 1 ;
	Tcount3 = ZERO ;
	while ( TRUE ) {
		if ( (Tcount1 > CDC_WAIT) ||
				(CDDA_NOW_status == CDDA_STAT_NOTREADY) ) {
			checkstatus() ;
			Tcount1 = 0 ;
		}
		if ( Tcount1 < 0 ) Tcount1 = CDC_WAIT + 1 ;
		if ( Tcount2 < 0 ) Tcount2 = PRG_WAIT + 1 ;
		if ( Tcount3 < 0 ) Tcount3 = NOA_WAIT + 1 ;
		if ( event() ) break ;
		if ( KEY_event() ) break ;
	} ;
	timer_end() ;								/*  ϊ荞ݏI			*/
	KYB_clrbuf() ;
}

/*****************************  CDtײ؎  ****************************/
int main( int ac,char *av[] )
/*=============================================================================
**	MAIN ٰ
**
**	< INPUT  > : Nײ
**	< OUTPUT > : Ȃ
**	< RETURN > : ʏ 0 , ߼ݽװ̎́A1
=============================================================================*/
{
	char	cons, err ;
	int		c, cc, arglen ;
	extern coninit() ;

/*-----------------------------------------------------------------------------
**	(߼ݽ)̏s.
**	߼݂w肳ꂽꍇɂ́A۸тI.
-----------------------------------------------------------------------------*/
	cons = FALSE ;
	err  = FALSE ;
	if ( ac > 1 ) {										/*  	*/
		for ( c=1; c<ac; c++ ) {
			if ( *av[c] == '-' || *av[c] == '/' ) {		/* ߼ݽ	*/
				arglen = strlen( av[c] ) ;
				for ( cc=1; cc<arglen; cc++ ) {
					switch ( *(av[c]+cc) ) {
					case '/' :
					case '-' :
						break ;
					case 'c' :
					case 'C' :
						cons = TRUE ;
						break ;
					case 'p' :
					case 'P' :
						Startplay = TRUE ;
						break ;
					case 's' :
					case 'S' :
						CDDA_FLG_stop = FALSE ;
						break ;
					case 'd' :
					case 'D' :
						CDDA_DEBUG = TRUE ;
						break ;
					default :
						printf("\x1b[33m") ;
						printf("Option switch error: %c",*(av[c]+cc)) ;
						printf("\x1b[m\n") ;
						err = TRUE ;
					}
				}
			} else {
				printf("\x1b[31m") ;
				printf("Parameter error: %s",av[c]) ;
				printf("\x1b[m\n") ;
				err = TRUE ;
			}
		}
	}
	if ( err ) exit( TRUE ) ;

/*-----------------------------------------------------------------------------
**	INT23h(CTRL+C)INT24(CRITICAL ERROR)  Ͻ .
-----------------------------------------------------------------------------*/
	int24_mask() ;

/*-----------------------------------------------------------------------------
**	CD PLAYER ̊Jn
-----------------------------------------------------------------------------*/
	init() ;									/*  					*/
	start() ;

/*-----------------------------------------------------------------------------
**	CD PLAYER ̏I
-----------------------------------------------------------------------------*/
	MOS_end() ;									/*  ϳI					*/
	while ( TRUE ) {
		if ( !SND_pcm_status( EXIT_CH ) ) break ;
		MOS_rdpos( &Mosbot,&Mosx,&Mosy ) ;
		if ( Mosbot ) break ;
	}
	SNDPLAY_stop( EXIT_CH ) ;
	SND_end() ;									/*  ޏI				*/

/*-----------------------------------------------------------------------------
**	̏I
-----------------------------------------------------------------------------*/
	if ( !CDDA_FLG_stop ) ELEVOL_set( ELEVOL_CD,Evol+1,Evol+1 ) ;
	else				  ELEVOL_mute() ;

/*-----------------------------------------------------------------------------
**	ݿىʂɖ߂
-----------------------------------------------------------------------------*/
	if ( cons ) {
		EGB_init( Gwork,GworkSize ) ;	/*  Ђ EGB 		*/
		EGB_clearScreen( Gwork ) ;
		coninit() ;
	}

	return( ZERO ) ;
}

